#include<bits/stdc++.h>
using namespace std;
const int maxN=100005;
int a[maxN];
int br[32];
int stepeni[31];
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    stepeni[0]=1;
    for(int i=1; i<31; i++)
        stepeni[i]=stepeni[i-1]*2;
    for(int k=0; k<31; k++)
    {
        br[k]=0;
    }
    int n;
    cin>>n;
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
        for(int k=0; k<31; k++)
        {
            int nja=a[i]&stepeni[k];
            if(nja>0)
            {
                br[k]++;
            }
        }
    }
    int q;
    cin>>q;
    while(q--)
    {
        int vrsta;
        cin>>vrsta;
        if(vrsta==0)
        {
            int p;
            cin>>p;
            int r=0;
            for(int k=0; k<31; k++)
            {
                if(br[k]>=p)
                    r+=stepeni[k];
            }
            cout<<r<<endl;
        }
        else if(vrsta==1)
        {
            int p,x;
            cin>>p>>x;
            for(int k=0; k<31; k++)
            {
                int nja=a[p]&stepeni[k];
                if(nja>0)
                    br[k]--;
            }
            a[p]=x;
            for(int k=0; k<31; k++)
            {
                int nja=a[p]&stepeni[k];
                if(nja>0)
                    br[k]++;
            }
        }
    }
    return 0;
}